QGIS Application - Bug report #20861

Function "round" in expressions assumes a strange behavior on negative numbers when the
parameter "places" is assigned.

2018-12-21 04:02 AM - Gabriel De Luca

Status: Closed

Priority: Normal

Assignee: Loic BARTOLETTI

Category: Expressions

Affected QGIS version:3.5(master) Regression?: No
Operating System: Easy fix?: No
Pull Request or Patch supplied: Resolution:

Crashes QGIS or corrupls data: Copied to github as #: 28680
Description

Function "round" in expressions assumes a strange behavior on negative numbers when the parameter "places" is assigned.

Tested on attributes of type "Decimal number (real)".

It does not happen when applied to positive numbers or when the "places" parameter is not specified.

Tested on QGIS 3.4.2, Windows 10, with all plugins disabled or not.

Associated revisions

Revision cfdc8c26 - 2019-01-29 05:27 PM - Loic BARTOLETTI

[BUGFIX] fix ggsRound for negative numbers. Fixes #20861

Revision 3f0171b8 - 2019-02-01 10:07 AM - Loic BARTOLETTI

[BUGFIX] fix ggsRound for negative numbers. Fixes #20861

(cherry picked from commit cfdc8c26c29baaf4ab62c9a94df9208dff3f6beda)

History

#1 - 2019-01-29 11:08 AM - Loic BARTOLETTI

- Operating System deleted (Windows 10)

- Affected QGIS version changed from 3.4.2 to 3.5(master)

- Assignee set to Loic BARTOLETTI

- Status changed from Open to Feedback

Can you describe the problem more precisely by including the treatment involved and the expected outcome.
For my part, | observed a problem with rounding, e. g:

round(-1234.567, 2) => -1234.56 instead of -1234.57 (in comparison with postgis or python)

Is it the same problem?
#2 - 2019-01-29 05:26 PM - Loic BARTOLETTI
- % Done changed from 0 to 100
- Status changed from Feedback to Closed

Applied in changeset commit:qgis|cfdc8c26c29baaf4a62c9a94df9208dff3f6beda.

#3 - 2019-01-30 12:18 AM - Gabriel De Luca

Loic BARTOLETTI wrote:

Is it the same problem?

Yes, also round( -100.00, 1) returns -99.9 instead of -100.0

Thanks for fix it.
